//+------------------------------------------------------------------+
//| This EA should be good for eurusd with default setting.          |
//|                For M5 timeframe only                             |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "newdigital"
#property link      "http://www.forex-tsd.com"

extern int                MagicFactor = 10;
int MagicNumber;

extern bool            NoHedge        = true;  //the main "hedge /no hedge" switch. If set to false, it will not check any hedged positions
extern bool            StrictNoHedge  = true;  //the way how hedging is checked; If set to true, it will check the entire account for the 
                                               //symbol the EA is attached to and if any "counter" order is opened it will prevent a new 
                                               //order to be opened in the opposite way. If set to false, it will check the symbol the EA 
                                               //is attached to only within given magic number (so, it will prevent hedging only within EA 
                                               //not within account) If broker does not allow hedging, you must set this parameter to true, 
                                               //but it is useful in cases when someone wants to test it and the effect of the no hedging 
                                               //rule to it's work (author mladen)
extern bool              EachTickMode = true;
extern double                    Lots = 0.1;
extern bool                     MM    = true;     //Use Money Management or not
extern int                     Risk   = 15;       //10%
extern bool             MicroAccount  = false;
extern int                   Slippage = 3;
extern bool              StopLossMode = True;
extern int                   StopLoss = 100;
extern bool            TakeProfitMode = True;
extern int                 TakeProfit = 100;
extern bool      TrailingStopMode     = True;
extern int           TrailingStop     = 30;
extern double       MaximumRisk       = 0;
extern double       DecreaseFactor    = 3;
extern int                MaxOrders   = 3;
extern double            iSAR_Step    = 0.05;
extern double          iSAR_Maximum   = 0.5;
extern int             iSAR_Shift     = 0;
extern double            BoxSize      = 5;        //ixoah
extern double            buylevel     = 1;        //ixoah buy level, should be 0 or above
extern double            selllevel    =-1;        //ixoah sell level should be 0 or below
extern double       Phase             = 5;        //jma phase
extern double       JMA_FastLength    = 7;        // Fast Jurik MA Period for JMA-Cross trend detection method
extern double       JMA_SlowLength    = 40;       // slow Jurik MA Period for JMA-Cross trend detection method
extern double          FastJMA        = 120;       //turbo jurik macd
extern double          SlowJMA        = 40;       //turbo jurik macd
extern double          SignalSMA      = 21;       //turbo jurik macd
extern double          FastJMAPhrase  =  5;       //turbo jurik macd
extern double          SlowJMAPhrase  =  5;       //turbo jurik macd

extern bool UseHourTrade = false;
extern int FromHourTrade = 0;
extern int ToHourTrade = 24;

extern bool ECNbroker = true;


#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

int PipMultiplier=1;
int BarCount;
int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
//MagicNo. Calc.
   int MNEACode, MNSymbol, MNPeriod, a;
   MNPeriod=Period();
   for (a = 0; a < 7; a++) MNSymbol += StringGetChar(Symbol(), a);
   for (a = 0; a < StringLen(WindowExpertName())+1; a++) MNEACode += StringGetChar(WindowExpertName(), a);
   MagicNumber =MagicFactor * MNSymbol+10*MNPeriod+10*MNEACode;  

   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   if (UseHourTrade){
      if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)) {
         Comment("Time for trade has not come else!");
         return(0);
      }  
   }
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   if(MM==true) Lots = LotSize(); //Adjust the lot size
   double StopLossLevel, TakeProfitLevel;
   double BuyStop, SellStop;
   int digit  = MarketInfo(Symbol(),MODE_DIGITS);
   if(digit==3 || digit==5) PipMultiplier=10;

   if (EachTickMode && Bars != BarCount) EachTickMode = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;
   
   //+------------------------------------------------------------------+
   //| Signal Begin                                                     |
   //+------------------------------------------------------------------+

      double Buy1_1 = iCustom(NULL,0,"Turbo_JMA",JMA_FastLength,Phase,0,1);
      double Buy1_2 = iCustom(NULL,0,"Turbo_JMA",JMA_SlowLength,Phase,0,1);
      double Buy2_1 = iCustom(NULL,0,"Turbo_JMA",JMA_FastLength,Phase,0,0);
      double Buy2_2 = iCustom(NULL,0,"Turbo_JMA",JMA_SlowLength,Phase,0,0);
      double Buy3_1 = iSAR(NULL, 0, iSAR_Step, iSAR_Maximum, Current + 1);
      double Buy3_2 = iSAR(NULL, 0, iSAR_Step, iSAR_Maximum, Current + 0);
      double Buy4_1 = iCustom(NULL,0,"Turbo_JMACD",FastJMA,SlowJMA,SignalSMA,FastJMAPhrase,SlowJMAPhrase,0,1);
      double Buy4_2 = iCustom(NULL,0,"Turbo_JMACD",FastJMA,SlowJMA,SignalSMA,FastJMAPhrase,SlowJMAPhrase,0,0);
      double Buy5_1 = iCustom(NULL,0,"Turbo_JMACD",FastJMA,SlowJMA,SignalSMA,FastJMAPhrase,SlowJMAPhrase,1,1);
      double Buy5_2 = iCustom(NULL,0,"Turbo_JMACD",FastJMA,SlowJMA,SignalSMA,FastJMAPhrase,SlowJMAPhrase,1,0);
      double Sell1_1 = iCustom(NULL,0,"Turbo_JMA",JMA_FastLength,Phase,0,1);
      double Sell1_2 = iCustom(NULL,0,"Turbo_JMA",JMA_SlowLength,Phase,0,1);
      double Sell2_1 = iCustom(NULL,0,"Turbo_JMA",JMA_FastLength,Phase,0,0);
      double Sell2_2 = iCustom(NULL,0,"Turbo_JMA",JMA_SlowLength,Phase,0,0); 
      double Sell3_1 = iSAR(NULL, 0, iSAR_Step, iSAR_Maximum, Current + 1);
      double Sell3_2 = iSAR(NULL, 0, iSAR_Step, iSAR_Maximum, Current + 0);
      double Sell4_1 = iCustom(NULL,0,"Turbo_JMACD",FastJMA,SlowJMA,SignalSMA,FastJMAPhrase,SlowJMAPhrase,0,1);
      double Sell4_2 = iCustom(NULL,0,"Turbo_JMACD",FastJMA,SlowJMA,SignalSMA,FastJMAPhrase,SlowJMAPhrase,0,0);
      double Sell5_1 = iCustom(NULL,0,"Turbo_JMACD",FastJMA,SlowJMA,SignalSMA,FastJMAPhrase,SlowJMAPhrase,1,1);
      double Sell5_2 = iCustom(NULL,0,"Turbo_JMACD",FastJMA,SlowJMA,SignalSMA,FastJMAPhrase,SlowJMAPhrase,1,0);
      double diIXO10 = iCustom(NULL,0,"XO_forEA",BoxSize,0,0);
      double diIXO21 = iCustom(NULL,0,"XO_forEA",BoxSize,1,0);
      double d22=(buylevel);
      double d24=(selllevel);

      if (Buy1_1 <= Buy1_2 && Buy2_1 > Buy2_2 && Buy3_1 < Buy3_2 && Buy4_1 < Buy4_2 && diIXO10 > d22) Order = SIGNAL_BUY;
      if (Sell1_1 >= Sell1_2 && Sell2_1 < Sell2_2 && Sell3_1 > Sell3_2 && Sell4_1 > Sell4_2 && diIXO21 < d24) Order = SIGNAL_SELL;

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))) && checkhedge(OP_BUY)) {
      if(ScanTrades() < MaxOrders) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (StopLoss >0 ) StopLossLevel = Ask - StopLoss * Point * PipMultiplier ; else StopLossLevel = 0;
         if (TakeProfit > 0) TakeProfitLevel = Ask + TakeProfit * Point * PipMultiplier ; else TakeProfitLevel = 0;
         
         if (!ECNbroker){
            Ticket = OrderSend(Symbol(), OP_BUY, LotsOptimized(), 
                     NormalizeDouble(Ask,digit), 
                     Slippage, 
                     NormalizeDouble(StopLossLevel,digit),  
                     NormalizeDouble(TakeProfitLevel,digit),  
                     "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
            if(Ticket > 0) {
               if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) Print("BUY order opened : ", OrderOpenPrice()); 
               else Print("Error opening BUY order : ", GetLastError());
            }
            else Print("Error opening BUY order : ", GetLastError());
         }
         else {
            Ticket = OrderSend(Symbol(), OP_BUY, LotsOptimized(), 
                     NormalizeDouble(Ask,digit), 
                     Slippage, 
                     0,  
                     0,  
                     "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
            if(Ticket > 0) {
              if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
                  OrderModify(Ticket,OrderOpenPrice(),NormalizeDouble(StopLossLevel,digit),NormalizeDouble(TakeProfitLevel,digit),0,CLR_NONE);
                  Print("BUY order opened : "       , OrderOpenPrice());
              } 
              else Print("Error opening BUY order : ", GetLastError());                    
            }
            else Print("Error opening BUY order : ", GetLastError());
         }   
         
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount))) && checkhedge(OP_SELL)) {
      if(ScanTrades() < MaxOrders) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }
         if (StopLoss >0 ) StopLossLevel = Bid + StopLoss * Point * PipMultiplier; else StopLossLevel = 0;
         if (TakeProfit > 0) TakeProfitLevel = Bid - TakeProfit * Point * PipMultiplier; else TakeProfitLevel = 0;
         
         if (!ECNbroker){
            Ticket = OrderSend(Symbol(), OP_SELL, LotsOptimized(), 
                     NormalizeDouble(Bid,digit), 
                     Slippage, 
                     NormalizeDouble(StopLossLevel,digit),  
                     NormalizeDouble(TakeProfitLevel,digit),  
                     "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         
            if(Ticket > 0) {
              if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) Print("SELL order opened : ", OrderOpenPrice());
              else Print("Error opening SELL order : ", GetLastError());
            }
            else Print("Error opening SELL order : ", GetLastError());
         }
         else {
            Ticket = OrderSend(Symbol(), OP_SELL, LotsOptimized(), 
                     NormalizeDouble(Bid,digit), 
                     Slippage, 
                     0,  
                     0,  
                     "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
            if(Ticket > 0){
              if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
                  OrderModify(Ticket,OrderOpenPrice(),NormalizeDouble(StopLossLevel,digit),NormalizeDouble(TakeProfitLevel,digit),0,CLR_NONE);
                  Print("SELL order opened : "       , OrderOpenPrice());
              }        
              else Print("Error opening SELL order : ", GetLastError());             
            }
            else Print("Error opening SELL order : ", GetLastError());
         }  
           
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }   
   }

   //Check position
   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         if(OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber ) {
            //Close
            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (EachTickMode) TickCheck = True;
               if (!EachTickMode) BarCount = Bars;
               return(0);
            }
            //Trailing stop
            if(TrailingStopMode) 
            { 
            if (TrailingStop > 0) 
            BuyStop = Bid - Point * PipMultiplier * TrailingStop;
            else BuyStop = iSAR(NULL, 0,iSAR_Step, iSAR_Maximum , Current + 0);                   
                         
               if(BuyStop > OrderOpenPrice() || TrailingStop==0) 
               {
                  if(OrderStopLoss() < BuyStop) 
                  {
                  //Print(" BS=",BuyStop);  
                  OrderModify(OrderTicket(), OrderOpenPrice(), BuyStop, OrderTakeProfit(), 0, MediumSeaGreen);
                  if (!EachTickMode) BarCount = Bars;
                  return(0);
                  }
               }
            }
         } 
         else {
            if(OrderType()==OP_SELL && OrderMagicNumber()==MagicNumber) {
           
//Close
                if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
                   OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
                   if (EachTickMode) TickCheck = True;
                   if (!EachTickMode) BarCount = Bars;
                   return(0);
                }
//Trailing stop
                if (TrailingStopMode) {
                    if(TrailingStop > 0) SellStop = Ask + Point * PipMultiplier * TrailingStop;
                    else SellStop = iSAR(NULL, 0,iSAR_Step, iSAR_Maximum , Current + 0);                  
                  //Print(" BS=",SellStop);    
                    if( OrderOpenPrice() > SellStop || TrailingStop==0 ) {
                       if((OrderStopLoss() > SellStop) || (OrderStopLoss() == 0)) {
                         //Print(" SS=",SellStop);
                           OrderModify(OrderTicket(), OrderOpenPrice(), SellStop, OrderTakeProfit(), 0, DarkOrange);
                           if (!EachTickMode) BarCount = Bars;
                           return(0);
                       }
                    }
                }
            }
         }
      }
   }

   if (!EachTickMode) BarCount = Bars;
   Comment (ShowInfo());
   return(0);
}
//--------------------------------------
//FUNCTION Money Management             
//--------------------------------------
double LotSize()
{
     double lotMM = MathCeil(AccountFreeMargin() * Risk / 10000) / 10;
	 
	  if(MicroAccount && lotMM < 0.01)  lotMM = Lots;
   	  if (!MicroAccount && lotMM < 0.1) lotMM = Lots;
	  if (lotMM > 1.0) lotMM = MathCeil(lotMM);
	  if  (lotMM > 100) lotMM = 100;
	  return (lotMM);
}
//--------------------------------------
//FUNCTION ShowInfo
//--------------------------------------
string ShowInfo() {
   string ls_0 = "";
   ls_0 = StringConcatenate ("MagicNumber: ", MagicNumber, "\n");   

   double CurrentSpread = MarketInfo(Symbol(), MODE_SPREAD)/ PipMultiplier;
//   if(Point==0.00001||Point==0.001)
//   {
//        CurrentSpread/=10.0;
//   }
   ls_0 = StringConcatenate (ls_0, "CurrentSpread ", DoubleToStr(CurrentSpread, 1));
   return (ls_0);
}
//--------------------------------------
//FUNCTION ScanTrades
//--------------------------------------
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == MagicNumber) 
   numords++;
   }
   return(numords);
}  

//bool ExistPositions() {
//	for (int i=0; i<OrdersTotal(); i++) {
//		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
//			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) {
//				return(True);
//			}
//		} 
//	} 
//	return(false);
//}
//--------------------------------------
//FUNCTION LotsOptimized
//--------------------------------------
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   if(MaximumRisk>0)lot=NormalizeDouble(Lots*AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
   return(lot);
   }
//--------------------------------------
//FUNCTION checkhedge - for hedge/nohedge selection
//--------------------------------------
bool checkhedge(int openWhat){
   if (!NoHedge) return(true);
   for(int i=0; i < OrdersTotal(); i++){
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if (OrderSymbol() != Symbol()) continue;
      if (!StrictNoHedge && OrderMagicNumber() != MagicNumber) continue;
      
      if (OrderType() == OP_BUY  && openWhat == OP_SELL) return(false); 
      if (OrderType() == OP_SELL && openWhat == OP_BUY)  return(false); 
   }      
   return(true);
}